#include "migrate.h"

extern int fthread_marks_tab[];
extern int fthread_free_tab[];
extern int free_index;
extern struct sched_st dist_sched_st;
extern sched_t sched_list;

typedef void (*scanning_action) (value, value *);

extern void (*scan_roots_hook) (scanning_action f);

static void (*prev_scan_roots_hook) (scanning_action);

static void caml_thread_scan_roots(scanning_action action)
{

  /*{ //A TESTER
    int i=0;
    for(i=0 ; i < free_index ; i++){
      munmap((void*)((fthread_free_tab[i]+1)*sizeof(struct fthread_st)),
	     sizeof(struct fthread_st));
      {
	int f=0;
      }
      fthread_marks_tab[fthread_free_tab[i]]=0;
    }
    free_index=0;
  }*/

  {
    sched_t sched_ptr=sched_list->next;
    fthread_t fthread_ptr=sched_list->current->next;
    
    while(fthread_ptr != sched_list->current){ 

      if(fthread_ptr->bottom_of_stack != NULL){
	
	do_local_roots(action,fthread_ptr->bottom_of_stack,
		       fthread_ptr->last_return_address,
		       fthread_ptr->gc_regs,
		       fthread_ptr->local_roots);
      }
      fthread_ptr=fthread_ptr->next;
    }
    
    while(sched_ptr != sched_list){
      if(sched_ptr->current != NULL){
	fthread_ptr=sched_ptr->current;
	do{

      if(fthread_ptr->bottom_of_stack != NULL){
	do_local_roots(action,fthread_ptr->bottom_of_stack,
		       fthread_ptr->last_return_address,
		       fthread_ptr->gc_regs,
		       fthread_ptr->local_roots);
      }
	  fthread_ptr=fthread_ptr->next;
	}while(fthread_ptr != sched_ptr->current);
      }
      sched_ptr=sched_ptr->next;
    }while(sched_ptr != sched_list);
    
  } 


    /** Hook */
    if (prev_scan_roots_hook != NULL) (*prev_scan_roots_hook)(action);
}

value init(value unit)
{
  prev_scan_roots_hook = scan_roots_hook;
  scan_roots_hook = caml_thread_scan_roots; 
  init_scheduler(&dist_sched_st);
  dist_sched_st.status=1;
}
