(* tournoi de jeu de cartes *)

let table1=Fthread.create_scheduler();;
let table2=Fthread.create_scheduler();;
let finale=Fthread.create_scheduler();;

let nbr_vainqueur=ref 0;;
let finale_commencee=ref false;;
let passe=Fthread.create_event();;

let rec joueur (id,cartes)=
  match cartes with
      c :: rc -> 
	if c=0 
	then 
	  begin
	    Printf.printf "le joueur %d passe\n" id;
	    flush stdout;
	    Fthread.awaitn 1 passe;
	    joueur (id,rc)
	  end
	else 
	  if c>7
	  then 
	    begin
	      if !finale_commencee then
		begin
		  Printf.printf "joueur %d gagne\n" id;
		  flush stdout;
		  Pervasives.exit 0
		end;
	      Printf.printf "le joueur %d va en finale\n" id;
	      flush stdout;
	      incr nbr_vainqueur;
	      Fthread.link_to finale;
	      joueur (id, rc)
	    end
	  else 
	    begin
	      Printf.printf "joueur %d joue %d\n" id c;
	      flush stdout;
	      Fthread.cooperate();
	      joueur (id,rc)
	    end
    | _ -> 
	Printf.printf "joueur %d perdu\n" id;
	flush stdout;
	if !nbr_vainqueur = 2 then
	  begin
	    nbr_vainqueur:=0;
	    Fthread.start_scheduler finale
	  end
;;

for i=1 to 4 do
  Fthread.create table1 joueur (i,[1;0;2;4;0;3]);
  Fthread.create table2 joueur ((i+5),[2;1;0;4;3])
done;

Fthread.create table1 joueur (5,[1;2;8;4;4;3;2;8]);
Fthread.create table2 joueur (10,[1;8;3;3;2;8]);
Fthread.start_scheduler table1;
Fthread.start_scheduler table2;
Fthread.exit();;

